/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : Vector.cc                                                 */
/*************************************************************************/
/*************************************************************************/

#include "Vector.h"
#include <limits.h>
#include <iostream.h>

Vector::Vector(float *Val, int maxi)
{  Index = maxi;
   myValues = new float[Index];
   int i;
   for(i=0;i<Index;i++) myValues[i] = Val[i];
}// end of constructor 

Vector::Vector(int maxi)
{  Index = maxi;
   myValues = new float[Index];
   for(int i=0;i<Index;i++) myValues[i] = FLT_MIN;
}// end of constructor 

Vector::Vector(const Vector& RHS)
{  Index = RHS.Index;
   myValues = new float[Index];
   int i;
   for(i=0;i<Index;i++) myValues[i] = RHS.myValues[i];
}// end of constructor 

Vector::Vector()
{  Index = 1;
   myValues = new float[1];
   myValues[0] = FLT_MIN;
}// end of constructor

Vector::~Vector() { if(Index) delete [] myValues; }

float Vector::getElement(int ind)
{ return (ind>=0&&ind<Index?myValues[ind]:FLT_MIN); }

int Vector::size() { return Index; }

Vector Vector::operator=(const Vector& RHS) 
{  //if(Index) delete [] myValues; 
   Index = RHS.Index;
   myValues = new float[Index];
   for(int i=0;i<Index;i++) myValues[i] = RHS.myValues[i];
   return (*this); 
}// end of operator =

ostream& operator<<(ostream& os, const Vector& RHS)
{  os << "Index is : " << RHS.Index << " ";
   for(int i=0;i<RHS.Index;i++) os << RHS.myValues[i] << " ";
   return os;
}// end of opertor<<
